package net.shadowplay.http;

import java.io.IOException;
import java.util.StringTokenizer;


public class ContentType
{
	private String mime;
	private String encoding = null;
	protected static final String charset = "charset";
	protected static final int charLen = charset.length();
	
	public ContentType(String s)
		throws IOException
	{
		StringTokenizer tok = new StringTokenizer(s,";");
		if(tok.hasMoreTokens())
		{
			mime = tok.nextToken().trim();
			String t;
			while(tok.hasMoreTokens())
			{
				t = tok.nextToken().trim();
				if(t.length() > charLen)
				{
					int off;
					if(charset.equalsIgnoreCase(t.substring(0,charLen))
						&& (off = t.indexOf('=')) != -1
						&& t.length() > (off+1))
					{
						encoding = t.substring(off+1);
					}
				}
			}
		}
		else
		{
			throw new IOException("Content-Type is empty");
		}
	}
	public String getEncoding()
	{
		return encoding;
	}
	public String getMime()
	{
		return mime;
	}
}