/*
 * This software is copyright (c) 2004 by Shadowplay.net. It is released 
 * under the terms of the Artistic License.  Please refer to the file 
 * LICENSE for details.
 */

package net.shadowplay.http.cookie;


/**
 * @author Michael Dykman for Shadowplay.net
 */
public class Cookie
{
	protected String name;
	protected String value;
	private int hash;
	
	public Cookie(String name,	String value)
	{
		this.name = name;
		this.value = value;
		hash = name.hashCode();
		if(value != null)
		{
			hash ^= value.hashCode();
		}
	}
	public int hashCode()
	{
		return hash; 
	}
	public static Cookie makeCookie(String s, boolean show)
	{
		Cookie c = null;
		int offset;
		String n, v;
		
		char sep = ';';
		offset = s.indexOf(sep);
		if(offset == -1)
		{
			sep = ',';
			offset = s.indexOf(sep);
		}
		
		if((offset = s.indexOf(sep)) > 0)
		{
			v = s.substring(0,offset);
			if((offset = v.indexOf('=')) > 0)
			{
				n = v.substring(0,offset);
				if(v.length() > offset)
				{
					v = v.substring(offset+1);
					offset = v.indexOf(' ');
					if(offset == -1)
					{
						offset = v.indexOf('\t');
					}
					if(offset != -1)
					{
						v = v.substring(0,offset);
					}
				}
				else
				{
					v = "";
				}
			}
			else
			{
				n = v;
			}
			
			if(show)
			{
				System.out.println("Set-Cookie: " + n.trim() + '=' + v.trim());
			}
			
			c = new Cookie(n.trim(),v.trim());
		}
		return c;
	}
}
