/*
 * This software is copyright (c) 2004 by Shadowplay.net. It is released 
 * under the terms of the Artistic License.  Please refer to the file 
 * LICENSE for details.
 */
package net.shadowplay.wurml.filter;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.traversal.NodeFilter;

/**
 * @author Michael Dykman for Shadowplay.net 
 */

public class DiscoverIdFilter implements NodeFilter
{
	String id;
	public DiscoverIdFilter(String id)
	{
		this.id = id;
	}
	public short acceptNode(Node node)
	{
		short result = NodeFilter.FILTER_SKIP;
	
		NamedNodeMap attr = node.getAttributes();
		Node idn = attr.getNamedItem("id");
		if(idn != null && idn.getNodeValue().equals(id))
		{
			result = NodeFilter.FILTER_ACCEPT;
		}
		return result;
	}
}

