/*
 * This software is copyright (c) 2004 by Shadowplay.net. It is released 
 * under the terms of the Artistic License.  Please refer to the file 
 * LICENSE for details.
 */
package net.shadowplay.wurml.filter;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.traversal.NodeFilter;


/**
 * @author Michael Dykman for Shadowplay.net 
 */
public class InputFilter implements NodeFilter
{
	private String name;
	public InputFilter()
	{
		this(null);
	}
	
	public InputFilter(String name)
	{
		this.name = name;
	}
	public short acceptNode(Node node)
	{
		short result = NodeFilter.FILTER_SKIP;
		if(node.getNodeName().equalsIgnoreCase("input"))
		{
			if(name == null)
			{
				result = NodeFilter.FILTER_ACCEPT;
			}
			else
			{
				NamedNodeMap attr = node.getAttributes();
				Node nn = attr.getNamedItem("name");
				if(nn != null && name.equals(nn.getNodeValue()))
				{
					result = NodeFilter.FILTER_ACCEPT;
				}
			}
		}
		return result;
	}
}
