/*
 * This software is copyright (c) 2004 by Shadowplay.net. It is released 
 * under the terms of the Artistic License.  Please refer to the file 
 * LICENSE for details.
 */
package net.shadowplay.wurml.filter;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.traversal.NodeFilter;


/**
 * @author Michael Dykman for Shadowplay.net 
 */
public class OptionWithValues implements NodeFilter
{
	String name;
	/**
	 * @param name The name of the select node the option is in
	 */
	public OptionWithValues(String name)
	{
		this.name = name;
	}
	public short acceptNode(Node node)
	{
		short result = NodeFilter.FILTER_SKIP;
		if(node.getNodeName().equalsIgnoreCase("OPTION"))
		{
			Node parent = node.getParentNode();
			if(parent.getNodeName().equalsIgnoreCase("SELECT"))
			{
				NamedNodeMap pattr = parent.getAttributes();
				NamedNodeMap attr = node.getAttributes();
				Node nn = pattr.getNamedItem("name");
				if(nn != null 
					&& nn.getNodeValue().equalsIgnoreCase(name) 
					&& attr.getNamedItem("value") != null)
				{
					result = NodeFilter.FILTER_ACCEPT;
				}
			}
		}
		
		return result;
	}
}
