package net.shadowplay.wurml.filter;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.traversal.NodeFilter;


/**
 * @author Michael Dykman
 */
public class SetvarFilter implements NodeFilter
{
	String name;
	
	public SetvarFilter(String name)
	{
		this.name = name;
	}
	/**
	 * @see org.w3c.dom.traversal.NodeFilter#acceptNode(org.w3c.dom.Node)
	 */
	public short acceptNode(Node node)
	{
		short result = NodeFilter.FILTER_SKIP;
		if(node.getNodeName().equalsIgnoreCase("SETVAR"))
		{
			NamedNodeMap attr = node.getAttributes();
			Node n = attr.getNamedItem("name");
			if(n != null && name.equals(n.getNodeValue()))
			{
				result = NodeFilter.FILTER_ACCEPT;
			}
		}
		return result;
	}

}
