package net.shadowplay.wurml.input;

import java.io.UnsupportedEncodingException;
import java.util.Iterator;


/**
 * @author Michael Dykman
 */
public class ItJoin implements Iterator
{
//	private Iterable first;
	private Iterable second;
	private Iterator fIt;
	private Iterator sIt;
	private Object fObj = null;
	private boolean started = false;
	public ItJoin(Iterable first, Iterable second)
		throws UnsupportedEncodingException
	{
//		this.first = first;
		this.second = second;
		fIt = first.iterator();
		sIt = second.iterator();
	}
	public boolean hasNext()
	{
		boolean result = false;
		if(! started)
		{
			result = fIt.hasNext() && sIt.hasNext();
		}
		else
		{
			result = sIt.hasNext() || fIt.hasNext();
		}
		
		return result;
	}
	public Object next()
	{
		Object o;
		if(! started)
		{
			fObj = fIt.next();
			started = true;
		}
		
		if(sIt.hasNext())
		{
			o = new Pair(fObj,sIt.next());
		}
		else
		{
			fObj = fIt.next();
			sIt = second.iterator();
			o = new Pair(fObj,sIt.next());
		}
		return o;
	}
	public void remove()
	{
		throw new UnsupportedOperationException("this iterator does not support the remove() method");
	}
	
	public static class Pair
	{
		public Object first,second;
		public Pair(Object first, Object second)
		{
			this.first = first;
			this.second = second;
		}
	}
}
